<?php

namespace Drupal\billwerk_subscriptions_subscriptionjs\Form;

use Drupal\billwerk_subscriptions_entities\SubscriptionPlansManager;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Session\AccountInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Parent class for ZMP Billwerk Forms.
 */
abstract class BillwerkSubscriptionjsFormAbstract extends FormBase
{
  public function __construct(
    protected readonly AccountInterface $account,
    protected readonly SubscriptionPlansManager $subscriptionPlansManager)
  {

  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container)
  {
    return new static(
      $container->get('current_user'),
      $container->get('billwerk_subscriptions_entities.subscription_plans_manager'),
    );
  }

  public function buildForm(array $form, FormStateInterface $form_state)
  {
    // Add this library to prevent duplicate form submits:
    $form['#attached']['library'][] = 'core/drupal.form';
  }
}
